Subject: Re: bug#15312: Info (point-entered, point-left): Doc incomplete, hence incorrect

From: Eli Zaretskii <[email-masked]>
Date: Fri, 13 Sep 2013 18:59:26 +0300

> From: Stefan Monnier <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Fri, 13 Sep 2013 11:15:10 -0400
> 
> > Sorry, I don't understand what you are saying about the original issue
> > with point-entered/left.  Are you saying that the code works
> > correctly, or are you saying it has a bug?
> 
> That the code that uses the `point-entered/left' property (just like
> the code that uses the other mentioned properties like `display',
> `mouse-face', ...) considers runs of characters with the same property
> value as belonging together; which means that the text-property is used
> to specify a kind of interval.

Sorry, I'm still in the dark.  Does the code presented in
http://debbugs.gnu.org/cgi/bugreport.cgi?bug=15312#11 work correctly
and as expected, or does it not?  If the latter, what would you expect
that code to do instead?

> Clearly, this disagrees with:
> 
>     ,----  (info "(elisp) Not Intervals")
>     | "What are the properties of this character?"  So we have decided these
>     | are the only questions that make sense; we have not implemented asking
>     | questions about where intervals start or end.
>     `----
> 
> And actually the above text is incorrect/incomplete in the sense that
> next-single-property-change clearly implements a functionality that lets
> you "ask questions about where intervals start or end".

Actually, it doesn't disagree, if you keep in mind what RMS meant when
he wrote that text (intervals can and do overlap, while runs of text
properties cannot).  But IMO that is a completely different issue.
The original issue raised by this report was about point-entered/left
hooks, and the code presented in the above URL illustrates the issue.
I suggest that we solve that issue first.